Index: XIOS/dev/branch_openmp/extern/src_ep_dev/ep_dup.cpp
===================================================================
--- XIOS/dev/branch_openmp/extern/src_ep_dev/ep_dup.cpp	(revision 1518)
+++ XIOS/dev/branch_openmp/extern/src_ep_dev/ep_dup.cpp	(revision 1520)
@@ -7,52 +7,52 @@
 {
 
-  int MPI_Comm_dup(MPI_Comm comm, MPI_Comm *newcomm)
+  int MPI_Comm_dup_mpi(MPI_Comm comm, MPI_Comm *newcomm)
   {
-    if(!comm.is_ep)
-    {
-      Debug("Comm_dup MPI\n");
-      newcomm = new MPI_Comm;
-      newcomm->is_ep = comm.is_ep;
+    newcomm = new MPI_Comm;
+    (*newcomm)->is_ep = false;
 
-      ::MPI_Comm input = to_mpi_comm(comm.mpi_comm);
-      ::MPI_Comm *output = new ::MPI_Comm;
+    ::MPI_Comm *output = new ::MPI_Comm;
+      
+    ::MPI_Comm_dup(to_mpi_comm(comm->mpi_comm), output);
 
-      
-      ::MPI_Comm_dup(input, output);
+    (*newcomm)->mpi_comm = output;
+  }
 
-      newcomm->mpi_comm = output;
-
-      return 0;
-    }
-
-    if(comm.is_intercomm) return MPI_Comm_dup_intercomm(comm, newcomm);
-
-    // for intracomm
-    if(comm.mpi_comm == static_cast< ::MPI_Comm* >(MPI_COMM_NULL.mpi_comm)) return 0;
+  int MPI_Comm_dup_intracomm(MPI_Comm comm, MPI_Comm *newcomm)
+  {
+    int ep_rank_loc = comm->ep_comm_ptr->size_rank_info[1].first;
+    int num_ep      = comm->ep_comm_ptr->size_rank_info[1].second;
 
 
-    int my_rank = comm.ep_comm_ptr->size_rank_info[1].first;
-    int num_ep  = comm.ep_comm_ptr->size_rank_info[1].second;
-
-
-    if(0 == my_rank)
+    if(0 == ep_rank_loc)
     {
       MPI_Info info;
       MPI_Comm *out_comm;
-      ::MPI_Comm *mpi_dup = new ::MPI_Comm;
 
-      ::MPI_Comm in_comm = to_mpi_comm(comm.mpi_comm);
-
-      ::MPI_Comm_dup(in_comm, mpi_dup);
-
-      MPI_Comm_create_endpoints(mpi_dup, num_ep, info, out_comm);
-      comm.ep_comm_ptr->comm_list->mem_bridge = out_comm;
+      MPI_Comm_create_endpoints(comm->mpi_comm, num_ep, info, out_comm);
+      comm->ep_comm_ptr->comm_list[0]->mem_bridge = out_comm;
     }
 
-    MPI_Barrier(comm);
+    MPI_Barrier_local(comm);
 
-    *newcomm = (comm.ep_comm_ptr->comm_list->mem_bridge[my_rank]);
+    *newcomm = (comm->ep_comm_ptr->comm_list[0]->mem_bridge[ep_rank_loc]);
+    
+  }
 
-    return MPI_SUCCESS;
+  int MPI_Comm_dup(MPI_Comm comm, MPI_Comm *newcomm)
+  {
+    
+    if(!comm->is_ep)
+    {
+      Debug("MPI_Comm_dup with MPI\n");
+      return MPI_Comm_dup_mpi(comm, newcomm); 
+    }
+
+    if(comm->is_intercomm) return MPI_Comm_dup_intercomm(comm, newcomm);
+
+    
+    return MPI_Comm_dup_intracomm(comm, newcomm); 
+
+   
   }
 
@@ -60,78 +60,79 @@
   {
     
-    if(comm.mpi_comm == static_cast< ::MPI_Comm* >(MPI_COMM_NULL.mpi_comm)) return 0;
-
-    int my_rank = comm.ep_comm_ptr->size_rank_info[1].first;
-    int num_ep  = comm.ep_comm_ptr->size_rank_info[1].second;
+    int newcomm_ep_rank =comm->ep_comm_ptr->intercomm->size_rank_info[0].first; 
+    int newcomm_ep_rank_loc = comm->ep_comm_ptr->intercomm->size_rank_info[1].first;
+    int newcomm_num_ep = comm->ep_comm_ptr->intercomm->size_rank_info[1].second;
 
 
-    if(0 == my_rank)
+    if(0 == newcomm_ep_rank_loc)
     {
+      //printf("in dup , newcomm_ep_rank_loc = 0 :  ep %d\n", comm->ep_comm_ptr->intercomm->size_rank_info[0].first);
+
       MPI_Info info;
       MPI_Comm *out_comm;
-      ::MPI_Comm *mpi_dup = new ::MPI_Comm;
 
-      ::MPI_Comm in_comm = to_mpi_comm(comm.mpi_comm);
+      MPI_Comm_create_endpoints(comm->mpi_comm, newcomm_num_ep, info, out_comm);
 
-      ::MPI_Comm_dup(in_comm, mpi_dup);
+      ::MPI_Comm *mpi_inter_comm = new ::MPI_Comm;
+      ::MPI_Comm_dup(to_mpi_comm(comm->ep_comm_ptr->intercomm->mpi_inter_comm), mpi_inter_comm);
 
-      MPI_Comm_create_endpoints(mpi_dup, num_ep, info, out_comm);
-
-      ::MPI_Comm *mpi_inter = new ::MPI_Comm;
-
-      ::MPI_Comm_dup(to_mpi_comm(comm.ep_comm_ptr->intercomm->mpi_inter_comm), mpi_inter);
-      
-      for(int i=0; i<num_ep; i++)
+      for(int i=0; i<newcomm_num_ep; i++)
       {
-        out_comm[i].ep_comm_ptr->comm_label = comm.ep_comm_ptr->comm_list[i].ep_comm_ptr->comm_label;
-        out_comm[i].ep_comm_ptr->intercomm = new ep_intercomm;
-
-        out_comm[i].ep_comm_ptr->intercomm->mpi_inter_comm = mpi_inter;
-        out_comm[i].is_intercomm = true;
-
-        out_comm[i].ep_comm_ptr->intercomm->intercomm_rank_map = new RANK_MAP;
-        out_comm[i].ep_comm_ptr->intercomm->local_rank_map = new RANK_MAP;
-        out_comm[i].ep_comm_ptr->intercomm->remote_rank_map = new RANK_MAP;
-
-        int map_size = 0;
-        map_size = comm.ep_comm_ptr->comm_list[i].ep_comm_ptr->intercomm->intercomm_rank_map->size();
-        out_comm[i].ep_comm_ptr->intercomm->intercomm_rank_map->resize(map_size);
-        for(int ii=0; ii<map_size; ii++)
-          out_comm[i].ep_comm_ptr->intercomm->intercomm_rank_map->at(ii) = comm.ep_comm_ptr->comm_list[i].ep_comm_ptr->intercomm->intercomm_rank_map->at(ii);
-
-        map_size = comm.ep_comm_ptr->comm_list[i].ep_comm_ptr->intercomm->local_rank_map->size();
-        out_comm[i].ep_comm_ptr->intercomm->local_rank_map->resize(map_size);
-        for(int ii=0; ii<map_size; ii++)
-          out_comm[i].ep_comm_ptr->intercomm->local_rank_map->at(ii) = comm.ep_comm_ptr->comm_list[i].ep_comm_ptr->intercomm->local_rank_map->at(ii);
-
-        map_size = comm.ep_comm_ptr->comm_list[i].ep_comm_ptr->intercomm->remote_rank_map->size();
-        out_comm[i].ep_comm_ptr->intercomm->remote_rank_map->resize(map_size);
-        for(int ii=0; ii<map_size; ii++)
-          out_comm[i].ep_comm_ptr->intercomm->remote_rank_map->at(ii) = comm.ep_comm_ptr->comm_list[i].ep_comm_ptr->intercomm->remote_rank_map->at(ii);
+        out_comm[i]->is_intercomm = true;
+        out_comm[i]->ep_comm_ptr->comm_label = comm->ep_comm_ptr->comm_list[i]->ep_comm_ptr->comm_label;
+        out_comm[i]->ep_comm_ptr->intercomm = new ep_lib::ep_intercomm;
+#ifdef _showinfo
+        printf("new out_comm[%d]->ep_comm_ptr->intercomm = %p\n", i, out_comm[i]->ep_comm_ptr->intercomm);
+#endif
+        out_comm[i]->ep_comm_ptr->intercomm->mpi_inter_comm = mpi_inter_comm;
+      }
 
 
-        //out_comm[i].ep_comm_ptr->intercomm->intercomm_rank_map = comm.ep_comm_ptr->comm_list[i].ep_comm_ptr->intercomm->intercomm_rank_map;
-        //out_comm[i].ep_comm_ptr->intercomm->local_rank_map = comm.ep_comm_ptr->comm_list[i].ep_comm_ptr->intercomm->local_rank_map;
-        //out_comm[i].ep_comm_ptr->intercomm->remote_rank_map = comm.ep_comm_ptr->comm_list[i].ep_comm_ptr->intercomm->remote_rank_map;
-
-        out_comm[i].ep_comm_ptr->intercomm->local_comm = comm.ep_comm_ptr->comm_list[i].ep_comm_ptr->intercomm->local_comm;        
-        out_comm[i].ep_comm_ptr->intercomm->intercomm_tag = comm.ep_comm_ptr->comm_list[i].ep_comm_ptr->intercomm->intercomm_tag;
-
-        for(int j =0; j<3; j++)
-        {
-          out_comm[i].ep_comm_ptr->intercomm->size_rank_info[j] = comm.ep_comm_ptr->comm_list[i].ep_comm_ptr->intercomm->size_rank_info[j];
-        }
-
-      }
-
-      comm.ep_comm_ptr->comm_list->mem_bridge = out_comm;
+      comm->ep_comm_ptr->comm_list[0]->mem_bridge = out_comm;
     }
 
-    MPI_Barrier(comm);
+    MPI_Barrier_local(comm);
 
-    *newcomm = comm.ep_comm_ptr->comm_list->mem_bridge[my_rank];
+    *newcomm = (comm->ep_comm_ptr->comm_list[0]->mem_bridge[newcomm_ep_rank_loc]);
+
+    (*newcomm)->ep_comm_ptr->size_rank_info[0] = comm->ep_comm_ptr->size_rank_info[0];
+    (*newcomm)->ep_comm_ptr->size_rank_info[1] = comm->ep_comm_ptr->size_rank_info[1];
+    (*newcomm)->ep_comm_ptr->size_rank_info[2] = comm->ep_comm_ptr->size_rank_info[2];
+
+    (*newcomm)->ep_comm_ptr->intercomm->size_rank_info[0] = comm->ep_comm_ptr->intercomm->size_rank_info[0];
+    (*newcomm)->ep_comm_ptr->intercomm->size_rank_info[1] = comm->ep_comm_ptr->intercomm->size_rank_info[1];
+    (*newcomm)->ep_comm_ptr->intercomm->size_rank_info[2] = comm->ep_comm_ptr->intercomm->size_rank_info[2];
+
+    (*newcomm)->ep_comm_ptr->intercomm->intercomm_tag = comm->ep_comm_ptr->intercomm->intercomm_tag;
+
+
+    int ep_rank_loc = (*newcomm)->ep_comm_ptr->size_rank_info[1].first;
+    
+    if(ep_rank_loc == 0)
+    {
+      int world_rank;
+      MPI_Comm_rank(MPI_COMM_WORLD, &world_rank);
+
+      (*newcomm)->ep_comm_ptr->intercomm->intercomm_rank_map = new INTERCOMM_RANK_MAP;
+      (*newcomm)->ep_comm_ptr->intercomm->local_rank_map = new EP_RANK_MAP;
+
+      *(*newcomm)->ep_comm_ptr->intercomm->intercomm_rank_map = *comm->ep_comm_ptr->intercomm->intercomm_rank_map;
+      *(*newcomm)->ep_comm_ptr->intercomm->local_rank_map     = *comm->ep_comm_ptr->intercomm->local_rank_map;
+    }
+
+    MPI_Barrier_local(comm);
+
+    if(ep_rank_loc !=0 )
+    {
+      int target = (*newcomm)->ep_comm_ptr->intercomm->intercomm_tag;
+      (*newcomm)->ep_comm_ptr->intercomm->intercomm_rank_map = (*newcomm)->ep_comm_ptr->comm_list[target]->ep_comm_ptr->intercomm->intercomm_rank_map; 
+      (*newcomm)->ep_comm_ptr->intercomm->local_rank_map     = (*newcomm)->ep_comm_ptr->comm_list[target]->ep_comm_ptr->intercomm->local_rank_map;
+    }
+
     
 
-    return MPI_SUCCESS;
+
+
+    
   }
 
Index: XIOS/dev/branch_openmp/extern/src_ep_dev/ep_exscan.cpp
===================================================================
--- XIOS/dev/branch_openmp/extern/src_ep_dev/ep_exscan.cpp	(revision 1518)
+++ XIOS/dev/branch_openmp/extern/src_ep_dev/ep_exscan.cpp	(revision 1520)
@@ -50,7 +50,7 @@
     valid_op(op);
 
-    int ep_rank_loc = comm.ep_comm_ptr->size_rank_info[1].first;
-    int num_ep = comm.ep_comm_ptr->size_rank_info[1].second;
-    int mpi_rank = comm.ep_comm_ptr->size_rank_info[2].first;
+    int ep_rank_loc = comm->ep_comm_ptr->size_rank_info[1].first;
+    int num_ep = comm->ep_comm_ptr->size_rank_info[1].second;
+    int mpi_rank = comm->ep_comm_ptr->size_rank_info[2].first;
     
 
@@ -60,9 +60,9 @@
     if(ep_rank_loc == 0 && mpi_rank != 0)
     {
-      comm.my_buffer->void_buffer[0] = recvbuf;
+      comm->my_buffer->void_buffer[0] = recvbuf;
     }
     if(ep_rank_loc == 0 && mpi_rank == 0)
     {
-      comm.my_buffer->void_buffer[0] = const_cast<void*>(sendbuf);  
+      comm->my_buffer->void_buffer[0] = const_cast<void*>(sendbuf);  
     } 
       
@@ -70,9 +70,9 @@
     MPI_Barrier_local(comm);
 
-    memcpy(recvbuf, comm.my_buffer->void_buffer[0], datasize*count);
+    memcpy(recvbuf, comm->my_buffer->void_buffer[0], datasize*count);
 
     MPI_Barrier_local(comm);
 
-    comm.my_buffer->void_buffer[ep_rank_loc] = const_cast<void*>(sendbuf);  
+    comm->my_buffer->void_buffer[ep_rank_loc] = const_cast<void*>(sendbuf);  
     
     MPI_Barrier_local(comm);
@@ -84,5 +84,5 @@
         assert(datasize == sizeof(int));
         for(int i=0; i<ep_rank_loc; i++)
-          reduce_sum<int>(static_cast<int*>(comm.my_buffer->void_buffer[i]), static_cast<int*>(recvbuf), count);    
+          reduce_sum<int>(static_cast<int*>(comm->my_buffer->void_buffer[i]), static_cast<int*>(recvbuf), count);    
       }
      
@@ -91,5 +91,5 @@
         assert(datasize == sizeof(float));
         for(int i=0; i<ep_rank_loc; i++)
-          reduce_sum<float>(static_cast<float*>(comm.my_buffer->void_buffer[i]), static_cast<float*>(recvbuf), count);    
+          reduce_sum<float>(static_cast<float*>(comm->my_buffer->void_buffer[i]), static_cast<float*>(recvbuf), count);    
       }
       
@@ -99,5 +99,5 @@
         assert(datasize == sizeof(double));
         for(int i=0; i<ep_rank_loc; i++)
-          reduce_sum<double>(static_cast<double*>(comm.my_buffer->void_buffer[i]), static_cast<double*>(recvbuf), count);
+          reduce_sum<double>(static_cast<double*>(comm->my_buffer->void_buffer[i]), static_cast<double*>(recvbuf), count);
       }
 
@@ -106,5 +106,5 @@
         assert(datasize == sizeof(char));
         for(int i=0; i<ep_rank_loc; i++)
-          reduce_sum<char>(static_cast<char*>(comm.my_buffer->void_buffer[i]), static_cast<char*>(recvbuf), count);
+          reduce_sum<char>(static_cast<char*>(comm->my_buffer->void_buffer[i]), static_cast<char*>(recvbuf), count);
       }
 
@@ -113,5 +113,5 @@
         assert(datasize == sizeof(long));
         for(int i=0; i<ep_rank_loc; i++)
-          reduce_sum<long>(static_cast<long*>(comm.my_buffer->void_buffer[i]), static_cast<long*>(recvbuf), count);
+          reduce_sum<long>(static_cast<long*>(comm->my_buffer->void_buffer[i]), static_cast<long*>(recvbuf), count);
       }
 
@@ -120,5 +120,5 @@
         assert(datasize == sizeof(unsigned long));
         for(int i=0; i<ep_rank_loc; i++)
-          reduce_sum<unsigned long>(static_cast<unsigned long*>(comm.my_buffer->void_buffer[i]), static_cast<unsigned long*>(recvbuf), count);    
+          reduce_sum<unsigned long>(static_cast<unsigned long*>(comm->my_buffer->void_buffer[i]), static_cast<unsigned long*>(recvbuf), count);    
       }
 
@@ -134,5 +134,5 @@
         assert(datasize == sizeof(int));
         for(int i=0; i<ep_rank_loc; i++)
-          reduce_max<int>(static_cast<int*>(comm.my_buffer->void_buffer[i]), static_cast<int*>(recvbuf), count);    
+          reduce_max<int>(static_cast<int*>(comm->my_buffer->void_buffer[i]), static_cast<int*>(recvbuf), count);    
       }
 
@@ -141,5 +141,5 @@
         assert(datasize == sizeof(float));
         for(int i=0; i<ep_rank_loc; i++)
-          reduce_max<float>(static_cast<float*>(comm.my_buffer->void_buffer[i]), static_cast<float*>(recvbuf), count);    
+          reduce_max<float>(static_cast<float*>(comm->my_buffer->void_buffer[i]), static_cast<float*>(recvbuf), count);    
       }
 
@@ -148,5 +148,5 @@
         assert(datasize == sizeof(double));
         for(int i=0; i<ep_rank_loc; i++)
-          reduce_max<double>(static_cast<double*>(comm.my_buffer->void_buffer[i]), static_cast<double*>(recvbuf), count);
+          reduce_max<double>(static_cast<double*>(comm->my_buffer->void_buffer[i]), static_cast<double*>(recvbuf), count);
       }
 
@@ -155,5 +155,5 @@
         assert(datasize == sizeof(char));
         for(int i=0; i<ep_rank_loc; i++)
-          reduce_max<char>(static_cast<char*>(comm.my_buffer->void_buffer[i]), static_cast<char*>(recvbuf), count);
+          reduce_max<char>(static_cast<char*>(comm->my_buffer->void_buffer[i]), static_cast<char*>(recvbuf), count);
       }
 
@@ -162,5 +162,5 @@
         assert(datasize == sizeof(long));
         for(int i=0; i<ep_rank_loc; i++)
-          reduce_max<long>(static_cast<long*>(comm.my_buffer->void_buffer[i]), static_cast<long*>(recvbuf), count);
+          reduce_max<long>(static_cast<long*>(comm->my_buffer->void_buffer[i]), static_cast<long*>(recvbuf), count);
       }
 
@@ -169,5 +169,5 @@
         assert(datasize == sizeof(unsigned long));
         for(int i=0; i<ep_rank_loc; i++)
-          reduce_max<unsigned long>(static_cast<unsigned long*>(comm.my_buffer->void_buffer[i]), static_cast<unsigned long*>(recvbuf), count);    
+          reduce_max<unsigned long>(static_cast<unsigned long*>(comm->my_buffer->void_buffer[i]), static_cast<unsigned long*>(recvbuf), count);    
       }
      
@@ -181,5 +181,5 @@
         assert(datasize == sizeof(int));
         for(int i=0; i<ep_rank_loc; i++)
-          reduce_min<int>(static_cast<int*>(comm.my_buffer->void_buffer[i]), static_cast<int*>(recvbuf), count);    
+          reduce_min<int>(static_cast<int*>(comm->my_buffer->void_buffer[i]), static_cast<int*>(recvbuf), count);    
       }
 
@@ -188,5 +188,5 @@
         assert(datasize == sizeof(float));
         for(int i=0; i<ep_rank_loc; i++)
-          reduce_min<float>(static_cast<float*>(comm.my_buffer->void_buffer[i]), static_cast<float*>(recvbuf), count);    
+          reduce_min<float>(static_cast<float*>(comm->my_buffer->void_buffer[i]), static_cast<float*>(recvbuf), count);    
       }
 
@@ -195,5 +195,5 @@
         assert(datasize == sizeof(double));
         for(int i=0; i<ep_rank_loc; i++)
-          reduce_min<double>(static_cast<double*>(comm.my_buffer->void_buffer[i]), static_cast<double*>(recvbuf), count);
+          reduce_min<double>(static_cast<double*>(comm->my_buffer->void_buffer[i]), static_cast<double*>(recvbuf), count);
       }
 
@@ -202,5 +202,5 @@
         assert(datasize == sizeof(char));
         for(int i=0; i<ep_rank_loc; i++)
-          reduce_min<char>(static_cast<char*>(comm.my_buffer->void_buffer[i]), static_cast<char*>(recvbuf), count);
+          reduce_min<char>(static_cast<char*>(comm->my_buffer->void_buffer[i]), static_cast<char*>(recvbuf), count);
       }
 
@@ -209,5 +209,5 @@
         assert(datasize == sizeof(long));
         for(int i=0; i<ep_rank_loc; i++)
-          reduce_min<long>(static_cast<long*>(comm.my_buffer->void_buffer[i]), static_cast<long*>(recvbuf), count);
+          reduce_min<long>(static_cast<long*>(comm->my_buffer->void_buffer[i]), static_cast<long*>(recvbuf), count);
       }
 
@@ -216,5 +216,5 @@
         assert(datasize == sizeof(unsigned long));
         for(int i=0; i<ep_rank_loc; i++)
-          reduce_min<unsigned long>(static_cast<unsigned long*>(comm.my_buffer->void_buffer[i]), static_cast<unsigned long*>(recvbuf), count);    
+          reduce_min<unsigned long>(static_cast<unsigned long*>(comm->my_buffer->void_buffer[i]), static_cast<unsigned long*>(recvbuf), count);    
       }
 
@@ -228,17 +228,17 @@
   int MPI_Exscan(const void *sendbuf, void *recvbuf, int count, MPI_Datatype datatype, MPI_Op op, MPI_Comm comm)
   {
-    if(!comm.is_ep)
-    {
-      return ::MPI_Scan(sendbuf, recvbuf, count, to_mpi_type(datatype), to_mpi_op(op), to_mpi_comm(comm.mpi_comm));
+    if(!comm->is_ep)
+    {
+      return ::MPI_Scan(sendbuf, recvbuf, count, to_mpi_type(datatype), to_mpi_op(op), to_mpi_comm(comm->mpi_comm));
     }
     
     valid_type(datatype);
 
-    int ep_rank = comm.ep_comm_ptr->size_rank_info[0].first;
-    int ep_rank_loc = comm.ep_comm_ptr->size_rank_info[1].first;
-    int mpi_rank = comm.ep_comm_ptr->size_rank_info[2].first;
-    int ep_size = comm.ep_comm_ptr->size_rank_info[0].second;
-    int num_ep = comm.ep_comm_ptr->size_rank_info[1].second;
-    int mpi_size = comm.ep_comm_ptr->size_rank_info[2].second;
+    int ep_rank = comm->ep_comm_ptr->size_rank_info[0].first;
+    int ep_rank_loc = comm->ep_comm_ptr->size_rank_info[1].first;
+    int mpi_rank = comm->ep_comm_ptr->size_rank_info[2].first;
+    int ep_size = comm->ep_comm_ptr->size_rank_info[0].second;
+    int num_ep = comm->ep_comm_ptr->size_rank_info[1].second;
+    int mpi_size = comm->ep_comm_ptr->size_rank_info[2].second;
 
     ::MPI_Aint datasize, lb;
@@ -253,5 +253,5 @@
     std::vector<int> my_map(mpi_size, 0);
 
-    for(int i=0; i<comm.rank_map->size(); i++) my_map[comm.rank_map->at(i).second]++;
+    for(int i=0; i<comm->ep_rank_map->size(); i++) my_map[comm->ep_rank_map->at(i).second]++;
 
     for(int i=0; i<mpi_rank; i++) my_src += my_map[i];
@@ -291,5 +291,5 @@
 
     if(ep_rank_loc == 0)
-      ::MPI_Exscan(MPI_IN_PLACE, tmp_recvbuf, count, to_mpi_type(datatype), to_mpi_op(op), to_mpi_comm(comm.mpi_comm));
+      ::MPI_Exscan(MPI_IN_PLACE, tmp_recvbuf, count, to_mpi_type(datatype), to_mpi_op(op), to_mpi_comm(comm->mpi_comm));
 
     // printf(" ID=%d : %d  %d \n", ep_rank, static_cast<int*>(tmp_recvbuf)[0], static_cast<int*>(tmp_recvbuf)[1]);
Index: XIOS/dev/branch_openmp/extern/src_ep_dev/ep_finalize.cpp
===================================================================
--- XIOS/dev/branch_openmp/extern/src_ep_dev/ep_finalize.cpp	(revision 1518)
+++ XIOS/dev/branch_openmp/extern/src_ep_dev/ep_finalize.cpp	(revision 1520)
@@ -22,12 +22,19 @@
   int MPI_Abort(MPI_Comm comm, int errorcode)
   {
-    int id = omp_get_thread_num();
+    if(!comm->is_ep)
+      return MPI_Abort_mpi(comm, errorcode);
 
-    if(id == 0)
+    else
     {
-      ::MPI_Comm mpi_comm = to_mpi_comm(comm.mpi_comm);
-      ::MPI_Abort(mpi_comm, errorcode);
+      if(comm->ep_comm_ptr->size_rank_info[1].first == 0)
+      {
+        ::MPI_Abort(to_mpi_comm(comm->mpi_comm), errorcode);
+      }
     }
-    return 0;
+  }
+
+  int MPI_Abort_mpi(MPI_Comm comm, int errorcode)
+  {
+    return ::MPI_Abort(to_mpi_comm(comm->mpi_comm), errorcode);
   }
 
Index: XIOS/dev/branch_openmp/extern/src_ep_dev/ep_fortran.cpp
===================================================================
--- XIOS/dev/branch_openmp/extern/src_ep_dev/ep_fortran.cpp	(revision 1518)
+++ XIOS/dev/branch_openmp/extern/src_ep_dev/ep_fortran.cpp	(revision 1520)
@@ -16,7 +16,7 @@
     void* fint = new ::MPI_Fint;
     #ifdef _intelmpi
-    *static_cast< ::MPI_Fint*>(fint) = (::MPI_Fint)(to_mpi_comm(comm.mpi_comm));
+    *static_cast< ::MPI_Fint*>(fint) = (::MPI_Fint)(to_mpi_comm(comm->mpi_comm));
     #elif _openmpi
-    *static_cast< ::MPI_Fint*>(fint) = MPI_Comm_c2f(to_mpi_comm(comm.mpi_comm));
+    *static_cast< ::MPI_Fint*>(fint) = MPI_Comm_c2f(to_mpi_comm(comm->mpi_comm));
     #endif
     
@@ -29,5 +29,5 @@
       {
         fc_comm_map.insert(std::make_pair( std::make_pair( *static_cast< ::MPI_Fint*>(fint), omp_get_thread_num()) , comm));
-        printf("EP_Comm_c2f : MAP %p insert: %d, %d, %p\n", &fc_comm_map, *static_cast< ::MPI_Fint*>(fint), omp_get_thread_num(), comm.ep_comm_ptr);
+        printf("EP_Comm_c2f : MAP %p insert: %d, %d, %p\n", &fc_comm_map, *static_cast< ::MPI_Fint*>(fint), omp_get_thread_num(), comm->ep_comm_ptr);
       }
     }
@@ -52,5 +52,5 @@
       MPI_Comm comm_ptr;
       comm_ptr = it->second;
-      printf("EP_Comm_f2c : MAP %p find: %d, %d, %p\n", &fc_comm_map, it->first.first, it->first.second, comm_ptr.ep_comm_ptr);
+      printf("EP_Comm_f2c : MAP %p find: %d, %d, %p\n", &fc_comm_map, it->first.first, it->first.second, comm_ptr->ep_comm_ptr);
       return  comm_ptr;
     }
@@ -65,5 +65,5 @@
     #endif
 
-    if(*base_comm != to_mpi_comm(MPI_COMM_NULL.mpi_comm))
+    if(*base_comm != to_mpi_comm(MPI_COMM_NULL->mpi_comm))
     {
       if(omp_get_thread_num() == 0)
